var canvas; var ctx; var connectors=[]; var color="#000000"; var addCl;

$(parent.window).load(function(){
// $(document).ready(function(){
	// $('body').hide()
	setUp()
	createWeeks();
	createLines();
	drawLines();
	drawAssessment();

});//end doc ready

function setUp(){

	// To create initial rendering of the DOM, and the canvas setup.

	$('#instructions,span.act').hide()
	$('#left').before('<canvas id="skToWk">')

	canvas = document.getElementById("skToWk");
	ctx = canvas.getContext("2d");
	canvas.width = 920;
	canvas.height = 630;
	ctx.lineWidth = 2;
}

function createWeeks(){

	// Gathers each list item to transfer span blocks as classnames and removes them from the DOM.

	$('#middle ul').prepend('<li id="skip"></li>')

	$('#middle li').each(function(i){
		if(i!=0){
			addCl = $(this).find('span.sk').text()
			$(this).addClass(addCl)
			$(this).find('span.sk').remove()
			// $(this).find('span.act').hide()
			$(this).before('<span class="wk" id="wk'+i+'">Week<br/>'+i+'</span>')
		}
	});//end each



}

function createLines(){

	// For each of the class names in list items, send skill, index and color to drawLines.

	$('#middle li').each(function(i){
		if(i!=0){
			skill = $(this).attr('class')
			skill.toString()

			if(skill.indexOf(' ') != -1 ){
				skill=skill.split(" ")
				for (var iSk = skill.length - 1; iSk >= 0; iSk--) {
					testCol(skill[iSk]);
					drawLines(skill[iSk],i,color);
				};
			}else{
				testCol(skill)
				drawLines(skill,i,color);
			}
		}
		connect()
	});//end each

	function testCol(skill){
		// Long way to check color, just ensuring colours match skill dot.
		if(skill=='skill1'){ color='#b030c5' }else if(skill=='skill2'){ color="#ff9100"	}else{ color='#009DD2' }
	}

}

function drawLines(skill,week,color){

	// Creates an array of to and from elements for canvas stroke

	skillNum = $('#' + skill)
	wkNum = $('#wk' + week);

	connectors.push({
	    from: skillNum,
	    to: wkNum,
	    col: color
	});

}

function connect() {

	// Creates and uses positions to draw stroke between two elements.

    ctx.clearRect(0, 0, canvas.width, canvas.height);
    for (var i = 0; i < connectors.length; i++) {
        var c = connectors[i];

        var skFrom = c.from;
        var wkTo = c.to;
        var stroke = c.col;

        var skMiddle = skFrom.height()/2 + 5
        var skTop = skFrom.offset().top - 3
        var skLineTop = skTop + skMiddle

        var skLeft = skFrom.width() + 19

        var wkMiddle = wkTo.height()
        var wkTop = wkTo.offset().top
        var wkLineTop = wkTop + wkMiddle

        var wkLeft = wkTo.width() + $('#left').width()

        ctx.beginPath();
        ctx.moveTo(skLeft, skLineTop);
        ctx.lineTo(wkLeft, wkLineTop);
        ctx.strokeStyle=stroke;
        ctx.stroke();

    }
}

function drawAssessment(){

	// To include dots next to topics associated with colour of assignment post it

	$('span.act').show()
	// $('span.act').css({'border-radius':'100%'})

	$('#middle li').each(function(i){
		if(i!=0){

			assessList=$(this).find('span.act').text()
			assessList.toString()

			if(assessList.indexOf(' ') != -1){
				assessList=assessList.split(" ")
				for (var iAss = assessList.length - 1; iAss >= 0; iAss--) {
					$(this).append('<span class="wrapAssess ' + assessList[iAss] + '">'+assessList[iAss]+'</span>')
				};
			}else{
				$(this).append('<span class="wrapAssess ' + assessList + '">'+assessList+'</span>')
			}
		}
	});//end each


	$('#middle li').each(function(i){
		if(i!=0){

			assessList=$(this).find('span.test').text()
			assessList.toString()

			if(assessList.indexOf(' ') != -1){
				assessList=assessList.split(" ")
				for (var iAss = assessList.length - 1; iAss >= 0; iAss--) {
					$(this).append('<span class="wrapTest ' + assessList[iAss] + '">'+assessList[iAss]+'</span>')
				};
			}else{
				$(this).append('<span class="wrapTest ' + assessList + '">'+assessList+'</span>')
			}
		}
	});//end each

	$('span.act,span.test').remove()

}
